<template>
  <v-container>
    <v-stepper v-model="e1" max-width="1200" class="mx-auto">
      <v-stepper-header>
        <v-stepper-step :complete="e1 > 1" step="1">
          Datos del Producto
        </v-stepper-step>

        <v-divider></v-divider>

        <v-stepper-step :complete="e1 > 2" step="2">
          Datos de la Compra
        </v-stepper-step>

        <v-divider></v-divider>

        <v-stepper-step step="3"> Resumen </v-stepper-step>
      </v-stepper-header>

      <v-stepper-items>
        <v-stepper-content step="1">
          <v-row align-content="center">
            <v-col>
              <v-card class="mb-2 mt-3 mx-1" max-width="550">
                <v-card-text>
                  <v-form
                    @submit="obtenerItem"
                    onSubmit="return false;"
                    ref="formUrl"
                    v-model="formUrlValido"
                  >
                    <v-row>
                      <v-col cols="9">
                        <v-text-field
                          v-model="url"
                          label="Pegue la URL del producto que quieres buscar"
                          required
                          :rules="urlRules"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="3" align-self="center">
                        <v-btn
                          color="success"
                          class="mr-4"
                          @click="obtenerItem"
                        >
                          Buscar
                        </v-btn>
                      </v-col>
                    </v-row>
                  </v-form>
                </v-card-text>
              </v-card>

              <v-card class="mb-1 mx-1" max-width="550">
                <v-card-text>
                  <v-form
                    ref="formItem"
                    v-model="formItemValido"
                    lazy-validation
                  >
                    <v-row>
                      <v-col>
                        <div class="font-weight-regular mb-1">
                          Imagen del Producto
                        </div>
                        <v-img
                          :src="datosProducto.imagen"
                          max-height="250"
                          max-width="250"
                          class="mx-auto my-5"
                        ></v-img>
                      </v-col>
                    </v-row>
                    <v-text-field
                      v-model="datosProducto.asin"
                      label="ASIN"
                      required
                      disabled
                      :rules="asinRule"
                    ></v-text-field>
                    <v-textarea
                      v-model="datosProducto.descripcion"
                      label="Nombre del Producto"
                      disabled
                    ></v-textarea>
                    <v-row>
                      <v-col>
                        <v-text-field
                          v-model="datosProducto.precio"
                          label="Precio"
                          required
                          v-on:change="calcularPrecio"
                          disabled
                        ></v-text-field>
                      </v-col>
                      <v-col>
                        <v-text-field
                          v-model="quotation.impuesto"
                          label="Impuesto"
                          required
                          v-on:change="calcularPrecio"
                          disabled
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-form>
                </v-card-text>
              </v-card>
            </v-col>
            <v-col>
              <v-card class="mb-1 mt-3 mx-1" max-width="550">
                <v-card-text>
                  <v-form ref="formDatos" v-model="formDatosValido">
                    <v-text-field
                      v-model="quotation.cantidad"
                      label="Cantidad"
                      v-on:change="calcularPrecio"
                      :rules="cantidadRules"
                      required
                    ></v-text-field>
                    <v-row>
                      <v-col>
                        <v-select
                          :items="unidades"
                          v-model="unidad"
                          item-text="name"
                          item-value="key"
                          return-object
                          label="Unidad de Medida"
                          v-on:change="calcularPrecio"
                          required
                          :rules="[
                            (v) =>
                              !!v.name || 'Seleccione una Unidad de Medida',
                          ]"
                        ></v-select>
                      </v-col>
                      <v-col>
                        <v-text-field
                          v-model="quotation.peso"
                          label="Peso"
                          required
                          v-on:change="calcularPrecio"
                          :rules="pesoRules"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                    <v-select
                      label="Empaque"
                      :items="enPaquete"
                      v-model="quotation.paquete"
                      v-on:change="calcularPrecio"
                      required
                      :rules="[(v) => !!v || '¿Empaque?']"
                    >
                    </v-select>
                    <v-select
                      label="Categoría"
                      :items="categorias"
                      v-model="categoria"
                      item-text="name"
                      item-value="key"
                      return-object
                      v-on:change="calcularPrecio"
                      required
                      :rules="[(v) => !!v.name || 'Seleccione una categoría']"
                    ></v-select>
                  </v-form>
                </v-card-text>
                <v-card-text>
                  <v-btn color="primary" class="mx-auto" block @click="toUser">
                    Continuar
                  </v-btn>
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
        </v-stepper-content>

        <v-stepper-content step="2">
          <v-row>
            <v-col>
              <v-card class="mb-1 mt-3 mx-auto" max-width="550">
                <v-card-text>
                  <v-form
                    ref="formUser"
                    v-model="formUserValido"
                    lazy-validation
                  >
                    <v-text-field
                      v-model="datosUser.name"
                      label="Usuario"
                      required
                      disabled
                    ></v-text-field>
                    <v-text-field
                      v-model="datosUser.user"
                      label="Nombre de Usuario"
                      required
                      disabled
                    ></v-text-field>
                    <v-text-field
                      v-model="datosUser.mail"
                      label="Correo Electrónico"
                      required
                      disabled
                    ></v-text-field>
                    <v-select
                      :items="ciudadesOrigen"
                      v-model="ciudadOrigen"
                      item-text="name"
                      item-value="key"
                      return-object
                      label="Ciudad de Origen"
                      v-on:change="calcularPrecio"
                      :rules="[
                        (v) => !!v.name || 'Seleccione una Ciudad de Origen',
                      ]"
                    ></v-select>
                    <v-select
                      label="Ciudad de Destino"
                      :items="ciudadesDestino"
                      v-model="ciudadDestino"
                      item-text="name"
                      item-value="key"
                      return-object
                      v-on:change="calcularPrecio"
                      :rules="[
                        (v) => !!v.name || 'Seleccione una Ciudad de Destino',
                      ]"
                    ></v-select>
                  </v-form>
                </v-card-text>
              </v-card>
            </v-col>
            <v-col>
              <v-card class="mx-auto mt-3" max-width="500">
                <v-card-title>{{ datosProducto.descripcion }}</v-card-title>
                <v-card-text>
                  <v-row>
                    <v-col class="font-weight-bold">Precio del Producto * {{ quotation.cantidad }}</v-col>
                    <v-col class="text-right"
                      >{{ quotation.precioTotal.toFixed(2) }} US$</v-col
                    >
                  </v-row>
                  <v-row>
                    <v-col class="font-weight-bold">Costo del Flete</v-col>
                    <v-col class="text-right"
                      >{{ quotation.flete.toFixed(2) }} US$</v-col
                    >
                  </v-row>
                  <v-row>
                    <v-col class="font-weight-bold">Costo del Arancel</v-col>
                    <v-col class="text-right"
                      >{{ quotation.arancel.toFixed(2) }} US$</v-col
                    >
                  </v-row>
                  <v-row>
                    <v-col class="font-weight-bold">Sub total</v-col>
                    <v-col class="text-right"
                      >{{ quotation.subTotal.toFixed(2) }} US$</v-col
                    >
                  </v-row>
                  <v-row v-if="quotation.descuento != 0">
                    <v-col class="font-weight-bold">Descuento</v-col>
                    <v-col class="text-right"
                      >-{{ quotation.descuento.toFixed(2) }} US$</v-col
                    >
                  </v-row>
                  <v-row>
                    <v-col class="font-weight-bold">Total</v-col>
                    <v-col class="text-right"
                      >{{ quotation.total.toFixed(2) }} US$</v-col
                    >
                  </v-row>
                  <v-divider class="mx-4 my-4"></v-divider>
                  <v-card-actions> </v-card-actions>
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>

          <v-card class="mt-5 mb-3" elevation="0">
            <v-btn color="primary" @click="toResumen"> Continuar </v-btn>
            <v-btn text @click="e1 = 1"> Atrás </v-btn>
          </v-card>
        </v-stepper-content>

        <v-stepper-content step="3">
          <v-row>
            <v-col cols="7">
              <v-card class="my-2 mx-1" elevation="5">
                <v-card-text>
                  <div class="text-overline">DATOS DE USUARIO</div>
                  <v-divider class="mb-2"></v-divider>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle>Usuario</v-list-item-subtitle>
                      <v-list-item-title>{{
                        datosUser.name
                      }}</v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle
                        >Nombre del Usuario</v-list-item-subtitle
                      >
                      <v-list-item-title
                        >{{ datosUser.user }}
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle
                        >Correo Electrónico</v-list-item-subtitle
                      >
                      <v-list-item-title
                        >{{ datosUser.mail }}
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                </v-card-text>
              </v-card>
              <v-card class="my-2 mx-1" elevation="5">
                <v-card-text>
                  <div class="text-overline">DATOS DEL ARTICULO</div>
                  <v-divider class="mb-2"></v-divider>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle>ASIN</v-list-item-subtitle>
                      <v-list-item-title
                        >{{ datosProducto.asin }}
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle
                        >Nombre del Producto</v-list-item-subtitle
                      >
                      <v-list-item-title
                        >{{ datosProducto.descripcion }}
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle>Cantidad</v-list-item-subtitle>
                      <v-list-item-title
                        >{{ quotation.cantidad }}
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-row no-gutters>
                    <v-col>
                      <v-list-item ripple>
                        <v-list-item-content>
                          <v-list-item-subtitle
                            >Unidad de Medida</v-list-item-subtitle
                          >
                          <v-list-item-title
                            >{{ quotation.unidad }}
                          </v-list-item-title>
                        </v-list-item-content>
                      </v-list-item>
                    </v-col>
                    <v-col>
                      <v-list-item ripple>
                        <v-list-item-content>
                          <v-list-item-subtitle>Peso</v-list-item-subtitle>
                          <v-list-item-title
                            >{{ quotation.peso }}
                          </v-list-item-title>
                        </v-list-item-content>
                      </v-list-item>
                    </v-col>
                  </v-row>
                  <v-row no-gutters>
                    <v-col>
                      <v-list-item ripple>
                        <v-list-item-content>
                          <v-list-item-subtitle>Empaque</v-list-item-subtitle>
                          <v-list-item-title
                            >{{ quotation.paquete }}
                          </v-list-item-title>
                        </v-list-item-content>
                      </v-list-item>
                    </v-col>
                    <v-col>
                      <v-list-item ripple>
                        <v-list-item-content>
                          <v-list-item-subtitle>Categoría</v-list-item-subtitle>
                          <v-list-item-title
                            >{{ quotation.categoria }}
                          </v-list-item-title>
                        </v-list-item-content>
                      </v-list-item>
                    </v-col>
                  </v-row>
                </v-card-text>
              </v-card>
            </v-col>
            <v-col cols="5">
              <v-card class="my-2 mx-1" elevation="5">
                <v-card-text>
                  <div class="text-overline">DATOS DE LA COMPRA</div>
                  <v-divider class="mb-2"></v-divider>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle
                        >Precio del Producto * {{ quotation.cantidad }}</v-list-item-subtitle
                      >
                      <v-list-item-title
                        >{{
                          quotation.precioTotal.toFixed(2)
                        }}
                        US$</v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle
                        >Costo del Flete</v-list-item-subtitle
                      >
                      <v-list-item-title
                        >{{ quotation.flete.toFixed(2) }} US$</v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle
                        >Costo del Arancel</v-list-item-subtitle
                      >
                      <v-list-item-title
                        >{{
                          quotation.arancel.toFixed(2)
                        }}
                        US$</v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle>Sub Total</v-list-item-subtitle>
                      <v-list-item-title
                        >{{
                          quotation.subTotal.toFixed(2)
                        }}
                        US$</v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple v-if="quotation.descuento != 0">
                    <v-list-item-content>
                      <v-list-item-subtitle>Descuento</v-list-item-subtitle>
                      <v-list-item-title
                        >{{
                          quotation.descuento.toFixed(2)
                        }}
                        US$</v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item ripple>
                    <v-list-item-content>
                      <v-list-item-subtitle>Total</v-list-item-subtitle>
                      <v-list-item-title
                        >{{ quotation.total.toFixed(2) }} US$</v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
          <v-card class="mt-5 mb-3" elevation="0">
            <v-btn color="primary" @click="registrar"> Registrar </v-btn>
            <v-btn text @click="e1 = 2"> Atrás </v-btn>
            <v-btn text @click="limpiar"> Cancelar </v-btn>
          </v-card>
        </v-stepper-content>
      </v-stepper-items>
    </v-stepper>
  </v-container>
</template>

<script lang="ts">
import { Vue, Component, getModule, VuexAction } from 'nuxt-property-decorator'
import ScrapStore from '~/store/scraping'
import UserStore from '@/store/user'
import QuotationStore from '@/store/quotation'
import CategoryStore from "@/store/category";

@Component({
  name: 'orden-compra',
})
export default class OrdenCompra extends Vue {
  e1 = 1
  url = ''

  urlRules = [(v: any) => !!v || 'Pege la url del producto']
  cantidadRules = [(v: any) => !!v || 'Digite la cantidad']
  pesoRules = [(v: any) => !!v || 'Digite el peso']

  asinRule = [(v: any) => !!v || 'Busque un producto']

  // FORMULARIO
  formUrlValido = true
  formItemValido = true
  formDatosValido = true
  formUserValido = true
  formResumenUserValido = true
  formResumenDatosValido = true

  enPaquete = ['Si', 'No']

  unidades = [
    { key: 1, name: 'Libras', val: 2.1 },
    { key: 2, name: 'Kilogramos', val: 2 },
    { key: 3, name: 'Onzas', val: 2.2 },
  ]
  unidad = { key: 0, name: '', val: 0 }
  categorias = [
    { key: 1, name: 'Laptop Standard', desct: 0 },
    { key: 2, name: 'Laptop Gamers', desct: 15 },
  ]
  categoria = { key: 0, name: '', desct: 0 }

  ciudadesOrigen = [
    { key: 1, name: 'Miami', val: 20 },
    { key: 2, name: 'New York', val: 21 },
    { key: 3, name: 'California', val: 30 },
  ]
  ciudadOrigen = { key: 0, name: '', val: 0 }
  ciudadesDestino = [
    { key: 1, name: 'Lima', val: 10 },
    { key: 2, name: 'Buenos Aires', val: 25 },
    { key: 3, name: 'Santiago', val: 20 },
  ]
  ciudadDestino = { key: 0, name: '', val: 0 }

  /* Cotización a enviar */
  quotation = {
    usuario: this.$auth.$storage.getUniversal('userId'),
    asin: '',
    cantidad: '',
    unidad: '',
    peso: '',
    paquete: '',
    categoria: '',
    precioTotal: 0,
    flete: 0,
    arancel: 0,
    subTotal: 0,
    descuento: 0,
    impuesto: 0,
    total: 0,
    origen: '',
    destino: '',
    estado: 0,
  }

  flete = 22
  arancel = 15
  impuesto = 0.18

  get datosProducto() {
    const valore = getModule(ScrapStore, this.$store)
    return valore.Scrap
  }

  obtenerItem(e: any) {
    e.preventDefault()
    const formUrl: any = this.$refs['formUrl']
    if (formUrl.validate()) {
      var objectSend = {
        url: this.url,
      }
      const scraping = getModule(ScrapStore, this.$store)
      scraping.getScrap(objectSend)
    }
  }

  calcularPrecio() {
    this.quotation.impuesto = this.datosProducto.precio * this.impuesto
    this.quotation.asin = this.datosProducto.asin
    this.quotation.unidad = this.unidad.name
    this.quotation.categoria = this.categoria.name
    this.quotation.origen = this.ciudadOrigen.name
    this.quotation.destino = this.ciudadDestino.name
    if (this.quotation.cantidad != '') {
      this.quotation.precioTotal =
        (parseFloat(this.datosProducto.precio) + this.quotation.impuesto) *
        parseFloat(this.quotation.cantidad)
      this.quotation.flete =
        this.flete +
        parseFloat(this.quotation.cantidad) *
          parseFloat(this.quotation.peso) *
          this.unidad.val +
        this.ciudadOrigen.val +
        this.ciudadDestino.val
      this.quotation.arancel =
        this.arancel +
        parseFloat(this.quotation.cantidad) * parseFloat(this.quotation.peso) +
        this.unidad.val
    }
    this.quotation.subTotal =
      this.quotation.precioTotal + this.quotation.flete + this.quotation.arancel

    if (this.categoria.desct != 0) {
      this.quotation.descuento =
        (this.quotation.precioTotal * this.categoria.desct) / 100
    } else {
      this.quotation.descuento = 0
    }
    this.quotation.total = this.quotation.subTotal - this.quotation.descuento
  }

  toUser() {
    const formDatos: any = this.$refs['formDatos']
    const formItem: any = this.$refs['formItem']
    const formUrl: any = this.$refs['formUrl']
    formDatos.validate()
    formItem.validate()
    formUrl.validate()
    if (formDatos.validate() && formItem.validate() && formUrl.validate()) {
      this.e1 = 2
      const id = this.$auth.$storage.getUniversal('userId')
      const user = getModule(UserStore, this.$store)
      user.getUSer(id)
      this.calcularPrecio()
    }
  }

  toResumen() {
    const formUser: any = this.$refs['formUser']
    if (formUser.validate()) {
      this.e1 = 3
    }
  }

  get datosUser() {
    const user = getModule(UserStore, this.$store)
    return user.user
  }

  limpiar() {
    const scraping = getModule(ScrapStore, this.$store)
    scraping.limpiarStore()
    this.unidad = { key: 0, name: '', val: 0 }
    this.categoria = { key: 0, name: '', desct: 0 }
    this.ciudadOrigen = { key: 0, name: '', val: 0 }
    this.ciudadDestino = { key: 0, name: '', val: 0 }
    this.url = ''
    this.quotation = {
      usuario: this.$auth.$storage.getUniversal('userId'),
      asin: '',
      cantidad: '',
      unidad: '',
      peso: '',
      paquete: '',
      categoria: '',
      precioTotal: 0,
      flete: 0,
      arancel: 0,
      subTotal: 0,
      descuento: 0,
      impuesto: 0,
      total: 0,
      origen: '',
      destino: '',
      estado: 0,
    }
    const formDatos: any = this.$refs['formDatos']
    const formUrl: any = this.$refs['formUrl']
    const formUser: any = this.$refs['formUser']
    formDatos.resetValidation()
    formUrl.resetValidation()
    formUser.resetValidation()
    this.e1 = 1
  }

  registrar() {
    this.quotation.estado = 1
    const create = getModule(QuotationStore, this.$store)
    create.createQuotation(this.quotation).then((e)=>{
      this.$router.push('/inicio/misordenes');
      this.limpiar()
    })
  }

  obtenerCategorias() {
    const cat = getModule(CategoryStore, this.$store)
    cat.getCategories().then((e) => {
      this.categorias = e
    })
  }

  created() {
    this.obtenerCategorias()
  }
}
</script>